
import java.io.*;
import java.util.*;


public class DataLoader {
    public Vector dlgTable   = new Vector( 10 );
    public Vector prxTable   = new Vector( 10 );
    public Vector envnTable  = new Vector( 10 );
    public Vector envvTable  = new Vector( 10 );
    public Vector pmtnTable  = new Vector( 10 );
    public Vector pmtvTable  = new Vector( 10 );


    public DataLoader() { }


    public void load( String prgtitle ) {
        try {
            BufferedReader br = new BufferedReader( new FileReader( prgtitle + ".txt" ) );
 
            while ( true ) {
                String line = br.readLine().trim();
                if      ( line.equals( prgtitle ) ) { break; }
                else if ( line.equals( "" ) || line.startsWith( "#" ) ) { continue; }

                else if ( line.startsWith( "Delegate" ) ) {
                    readLines( br, dlgTable, true );
                }
                else if ( line.startsWith( "Proxy" ) ) {
                    readLines( br, prxTable, true );
                }
                else if ( line.startsWith( "ENV" ) ) {
                    readPairs( br, envnTable, envvTable );
                }
                else if ( line.startsWith( "Parameter" ) ) {
                    readPairs( br, pmtnTable, pmtvTable );
                }
            }

            br.close();
        }
        catch ( Exception e ) {
            System.err.println( "Exception : " + e );
        }
    }


    void readLines( BufferedReader br, Vector table, boolean addh ) {
        try {
            while ( true ) {
                String line = br.readLine().trim();
                if      ( line.equals( "}" ) ) { break; }
                else if ( line.equals( "" ) || line.startsWith( "#" ) ) { continue; }
                else {
                    if ( addh && !line.startsWith( "http://" ) ) {
                        line = "http://" + line;
                    }
                    table.addElement( line );
                }
            }
        }
        catch ( Exception e ) {
            System.err.println( "Exception : " + e );
        }
    }


    void readPairs( BufferedReader br, Vector ntable, Vector vtable ) {
        try {
            while ( true ) {
                String line = br.readLine().trim();
                if      ( line.equals( "}" ) ) { break; }
                else if ( line.equals( "" ) || line.startsWith( "#" ) ) { continue; }
                else {
                    StringTokenizer st = new StringTokenizer( line, "=", false );
                    String name, value;
                    if ( st.hasMoreTokens() ) {
                        name  = st.nextToken().trim();
                        if ( st.hasMoreTokens() )
                             value = st.nextToken().trim();
                        else value = "";

                        ntable.addElement( name );
                        vtable.addElement( value );
                    }
                }
            }
        }
        catch ( Exception e ) {
            System.err.println( "Exception : " + e );
        }
    }


}
