
import java.io.*;
import java.net.*;


public class GDServer extends Thread {
    protected ServerSocket    s_socket = null;


    protected GDServer() { }


    public    GDServer( int port ) {
        try {
            s_socket = new ServerSocket( port );
        }
        catch ( Exception e ) {
            System.out.println( "ServerSocket Construction failure : " + e );
        }
    }


    public void close() {
        try {
            if ( s_socket != null ) { s_socket.close(); s_socket = null; }
            super.stop();
        }
        catch ( Exception e ) {
            System.out.println( "ServerSocket Closing failure : " + e );
        }
    }


    public void run() {
        try {
            while ( true ) {
                new GDSession( s_socket.accept() ).start();
            }
        }
        catch ( Exception e ) {
            System.out.println( "ServerSocket Acception failure : " + e );
        }
    }


}
