
import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class GabriDuke extends SkeletonFrame {
    GDServer    server     = null;
    int         port       = 8080;
    Duke        duke       = null;

    Choice      dlgChoice  = new Choice();
    Choice      prxChoice  = new Choice();
    Button      dukeButton = new Button( "DUKE" );
    TextField[] nameField  = null;
    TextField[] valueField = null;


    public static void main( String[] args ) {
        try {
            int port = ( args.length > 0 ) ? Integer.parseInt( args[0] ) : 8080;
            GabriDuke gd = new GabriDuke( port );
            gd.standAlone = true;
        }
        catch ( Exception e ) {
            System.out.println( "Exception : " + e );
            System.exit( 1 );
        }
    }


    public GabriDuke( int port ) {
        this.port = port;
        setTitle( "GabriDuke" );
        setLayout( null );
        setBackground( Color.lightGray );

        DataLoader loader = new DataLoader();
        loader.load( "GabriDuke" );

        Vector dlgTable  = loader.dlgTable;
        Vector prxTable  = loader.prxTable;
        Vector envnTable = loader.envnTable;
        Vector envvTable = loader.envvTable;
        Vector pmtnTable = loader.pmtnTable;
        Vector pmtvTable = loader.pmtvTable;

        int size = envnTable.size();
        width = 520; height = 100 + size * 30 + 20;
        setSize( width, height );


        Label dlgLabel = new Label( "DELEGATE" );
        Label prxLabel = new Label( "PROXY" );
        dlgLabel.  setBounds( width/2 - 170,  30,  60, 20 ); add( dlgLabel );
        prxLabel.  setBounds( width/2 +  40,  30,  60, 20 ); add( prxLabel );
        dlgChoice. setBounds( width/2 - 240,  50, 200, 20 ); add( dlgChoice );
        prxChoice. setBounds( width/2 -  30,  50, 200, 20 ); add( prxChoice );
        dukeButton.setBounds( width/2 + 180,  50,  60, 20 ); add( dukeButton );
        dlgChoice. add( "no delegate" );
        prxChoice. add( "no proxy" );
        prxChoice. add( "random proxy" );
        dukeButton.addActionListener( this );

        for ( int i = 0; i < dlgTable.size(); i++ )
            dlgChoice.add( (String)dlgTable.elementAt(i) );

        for ( int i = 0; i < prxTable.size(); i++ )
            prxChoice.add( (String)prxTable.elementAt(i) );

        if ( prxChoice.getItemCount() > 2 )
            prxChoice.select( 2 );


        Label envLabel = new Label( "ϐ" );
        envLabel.setBounds( width/2 - 40,  80,  80, 20 ); add( envLabel );
        nameField     = new TextField[ size ];
        valueField    = new TextField[ size ];

        for ( int i = 0; i < size; i++ ) {
            nameField[i]  = new TextField( (String)envnTable.elementAt(i) );
            valueField[i] = new TextField( (String)envvTable.elementAt(i) );
            add( nameField[i] );
            add( valueField[i] );

            nameField[i]. setBounds( width/2 - 250, 100 + ( i * 30 ), 140, 25 );
            valueField[i].setBounds( width/2 - 100, 100 + ( i * 30 ), 350, 25 );
        }


        duke = new Duke( this, pmtnTable, pmtvTable );

        server = new GDServer( port );
        server.start();
        GDSession.setGabriDuke( this );

        addWindowListener( this );
        goout();

        //System.out.println( getFields() ); // ...
    }


    public void actionPerformed( ActionEvent e ) {
        Object obj = e.getSource();
        if      ( obj == dukeButton ) {
            if ( !duke.isVisible() ) duke.goout();
        }
    }


    public String getDelegate()  {
        String str = dlgChoice.getSelectedItem();
        if ( str == null || str.equals( "no delegate" ) )
            return "";
        else
            return str;
    }

    public String getProxy() {
        String str = prxChoice.getSelectedItem();
        if ( str == null || str.equals( "no proxy" ) )
            return "";
        else {
            if ( str.equals( "random proxy" ) ) {
                int ct = prxChoice.getItemCount() - 2;
                if ( ct > 0 ) {
                    return prxChoice.getItem(
                        (int)( Math.random() *  (double)ct )  + 2 );
                }
                else
                    return str;
            }
            else
                return str;
        }
    }

    public String getFields() {
        StringBuffer sb = new StringBuffer();

        for ( int i = 0; i < nameField.length; i++ ) {
            String n = nameField[i]. getText();
            String v = valueField[i].getText();
            if ( n != null && !n.equals("") && v != null && !v.equals("") ) {
                sb.append( n );
                sb.append( ": " );
                sb.append( v );
                sb.append( "\r\n" );
            }
        }

        return sb.toString();
    }


    public void quit(){
        duke.dispose();
        //if ( server != null ) { server.close(); } // ...deleted for jview error
        super.quit();
    }



}
